#
# OpenStack Compute (Nova) API WSGI app skeleton
#

import eventlet
eventlet.monkey_patch()

import os
import sys

from paste import deploy

from nova import flags
from nova import log as logging
from nova import utils

utils.default_flagfile()
flags.FLAGS(sys.argv)
logging.setup()
utils.monkey_patch()

LOG = logging.getLogger(__name__)
app_name = os.path.basename(__file__).rsplit('.')[0]
config_path = utils.find_config(flags.FLAGS.api_paste_config)

if app_name in flags.FLAGS.enabled_apis:
    application = deploy.loadapp("config:%s" % config_path, name=app_name)
else:
    LOG.error("Not starting disabled Nova WSGI application '%s'" % app_name)

